QGIS Application - Feature request #8725
Speed improvement in the render of geometries for qgis
2013-09-30 01:48 AM - Alvaro Huarte

Status: Closed

Priority: Normal

Assignee: Alvaro Huarte

Category: Vectors

Pull Request or Patch stupplied: Resolution: fixed/implemented
Easy fix?: No Copied to github as #: 17441
Description

The render of geometries for vector layers in ggis can be optimized.
There are some tricks that sure make fast the rendering of big shapes:

- Prefilter the points of the geometries to be painted using a map2pixel error tolerance (_getPolygon and _getLineString in rendererv2).
- Prevents divisions in map to devices coordinates.

- Prevents of unnecessary trim of the geometries with the canvas rect.

- Prevents of unnecessary calloc using shared memory buffer (ogr to wkb in ogrFeaturelterator).

I have implements this tricks and qgis has better performance of 300% in some map situations.
| want validate the code and | will try share it.

History

#1 - 2013-09-30 02:07 AM - Matthias Kuhn

Hi Alvaro,

Thank you for looking into this issues and contributing.

The best thing to do is to open a pull request on github, so it can be reviewed, commented and eventually merged.

#2 - 2013-09-30 03:29 AM - Alvaro Huarte

Ok, thank you very much

#3 - 2013-09-30 03:38 AM - Matthias Kuhn

| forgot to mention that it would be best to make one pull request for each improvement. So in case one of them is not accepted, it will still be possible to

merge the good parts.

#4 - 2013-09-30 03:49 AM - Alvaro Huarte

ok, | will divide this issue in four single childs tasks.

Thank you!

#5 - 2013-10-04 04:34 AM - Giovanni Manghi
Hi Alvaro, do you have a branch that can be tested? Cheers!

#6 - 2013-10-04 12:48 PM - Alvaro Huarte
Hi Giovanni, | am testing my changes, if it successly in some days | will try a pull request.

Thank you very much!

#7 - 2013-10-05 03:27 AM - Alvaro Huarte
- % Done changed from 0 to 70
- File test_data_qgis_master_RenderingStatsQGIS__Feature-8725.zip added

I'm making progress, | think | get promising results. Attach a table of results for three tested layers.

#8 - 2013-10-05 03:30 AM - Giovanni Manghi

Alvaro Huarte wrote:

I'm making progress, | think | get promising results. Attach a table of results for three tested layers.

wow, | can't wait to test your patches! :)

#9 - 2013-10-05 07:35 PM - Alvaro Huarte
- Resolution set to fixed

- % Done changed from 70 to 100

- Status info set to for test

#10 - 2013-10-06 03:50 AM - Giovanni Manghi

Alvaro Huarte wrote:

done for test.

github:
https://github.com/ahuarte47/QGIS/commit/28691ff96e0ef2a97a8f1d08898b1c7d97941f7¢c

+

https://github.com/ahuarte47/QGIS/commit/a8894f8df811c61fe021607d474aa8e117a5f56f

Sorry there are two commits, | forgot to add one edited file

Hi Alvaro, can you please make a Pull Request in the qgis repo? This way other will be able to see it and review and then commit. Thanks!

#11 - 2013-10-06 12:56 PM - Alvaro Huarte

Done.

I'm new using gitub and I'm learning this tool, Sorry!
Thanks!

#12 - 2013-10-07 05:16 PM - Alvaro Huarte

Changes goto branch:

https://github.com/ahuarte47/QGIS/tree/lssue_8725

#13 - 2013-10-20 10:12 PM - Alvaro Huarte
- Pull Request or Patch supplied changed from No to Yes
- Resolution changed from fixed to fixed/implemented

| have implemented the simplification of geometries in the vector-providers. The general behavior simplifies the geometries post-fetch the feature from the

provider, but OGR-provider simplifies the geometries pre-fetch the features having a extra seed improvement.

Te final result gets ~3x painting speed faster that original code

New branch:
https://github.com/ahuarte47/QGIS/tree/Issue_8725-OGR

| think ready for test! :-)

#14 - 2013-10-22 04:42 AM - Giovanni Manghi

Alvaro Huarte wrote:

I have implemented the simplification of geometries in the vector-providers. The general behavior simplifies the geometries post-fetch the feature
from the provider, but OGR-provider simplifies the geometries pre-fetch the features having a extra seed improvement.

Te final result gets ~3x painting speed faster that original code

New branch:
https://github.com/ahuarte47/QGIS/tree/Issue_8725-OGR

| think ready for test! :-)

compiling right now :)

#15 - 2013-10-22 05:08 AM - Giovanni Manghi

| think ready for test! :-)

got an error during make

Building CXX object src/core/CMakeFiles/qgis_core.dir/ggsmaplayer.cpp.o
/home/giovanni/QGIS-Issue_8725-OGR/src/core/qgsmaprequest.cpp: In function ‘QgsRectangle calculateBoundingBox(const
QVector<QPointF>&)’:

/home/giovanni/QGIS-Issue_8725-OGR/src/core/qgsmaprequest.cpp:102:18:
/home/giovanni/QGIS-Issue_8725-OGR/src/core/qgsmaprequest.cpp:102:38:
/home/giovanni/QGIS-Issue_8725-OGR/src/core/qgsmaprequest.cpp:102:38:
/home/giovanni/QGIS-Issue_8725-OGR/src/core/qgsmaprequest.cpp:103:18:
/home/giovanni/QGIS-Issue_8725-OGR/src/core/qgsmaprequest.cpp:103:38:
/home/giovanni/QGIS-Issue_8725-OGR/src/core/qgsmaprequest.cpp:103:38:
/home/giovanni/QGIS-Issue_8725-OGR/src/core/qgsmaprequest.cpp:104:18:
/home/giovanni/QGIS-Issue_8725-OGR/src/core/qgsmaprequest.cpp:104:38:
/home/giovanni/QGIS-Issue_8725-OGR/src/core/qgsmaprequest.cpp:104:38:
/home/giovanni/QGIS-Issue_8725-OGR/src/core/qgsmaprequest.cpp:105:18:
/home/giovanni/QGIS-Issue_8725-OGR/src/core/qgsmaprequest.cpp:105:38:
/home/giovanni/QGIS-Issue_8725-OGR/src/core/qgsmaprequest.cpp:105:38:

error

error:

error:

error:

error:

error:

error:

error:

error:

error:

error:

error

: ‘numeric_limits’ is not a member of ‘std’
expected primary-expression before ‘double’
expected ‘, or ;" before ‘double’
‘numeric_limits’ is not a member of ‘std’
expected primary-expression before ‘double’
expected ‘,” or ;" before ‘double’
‘numeric_limits’ is not a member of ‘std’
expected primary-expression before ‘double’
expected ‘,” or ;" before ‘double’
‘numeric_limits’ is not a member of ‘std’
expected primary-expression before ‘double’
: expected ‘;’ or ;' before ‘double’

/home/giovanni/QGIS-Issue_8725-OGR/src/core/qgsmaprequest.cpp:109:5: error: X’ was not declared in this scope

/home/giovanni/QGIS-Issue_8725-OGR/src/core/qgsmaprequest.cpp:110:5: error: ‘y’ was not declared in this scope

/home/giovanni/QGIS-Issue_8725-OGR/src/core/qgsmaprequest.cpp: In function ‘QgsRectangle calculateBoundingBox(QGis::WkbType,

unsigned char*, std::size_t)’:

/home/giovanni/QGIS-Issue_8725-OGR/src/core/qgsmaprequest.cpp:125:18:
/home/giovanni/QGIS-Issue_8725-OGR/src/core/qgsmaprequest.cpp:125:38:
/home/giovanni/QGIS-Issue_8725-OGR/src/core/qgsmaprequest.cpp:125:38:
/home/giovanni/QGIS-Issue_8725-OGR/src/core/qgsmaprequest.cpp:126:18:
/home/giovanni/QGIS-Issue_8725-OGR/src/core/qgsmaprequest.cpp:126:38:
/home/giovanni/QGIS-Issue_8725-OGR/src/core/qgsmaprequest.cpp:126:38:
/home/giovanni/QGIS-Issue_8725-OGR/src/core/qgsmaprequest.cpp:127:18:
/home/giovanni/QGIS-Issue_8725-OGR/src/core/qgsmaprequest.cpp:127:38:
/home/giovanni/QGIS-Issue_8725-OGR/src/core/qgsmaprequest.cpp:127:38:
/home/giovanni/QGIS-Issue_8725-OGR/src/core/qgsmaprequest.cpp:128:18:
/home/giovanni/QGIS-Issue_8725-OGR/src/core/qgsmaprequest.cpp:128:38:
/home/giovanni/QGIS-Issue_8725-OGR/src/core/qgsmaprequest.cpp:128:38:

error:

error

error:

error:

error:

error:

error:

error:

error:

error:

error:

error

‘numeric_limits’ is not a member of ‘std’

: expected primary-expression before ‘double’
expected ‘, or ‘;’ before ‘double’
‘numeric_limits’ is not a member of ‘std’
expected primary-expression before ‘double’
expected ‘, or ‘;’ before ‘double’
‘numeric_limits’ is not a member of ‘std’
expected primary-expression before ‘double’
expected ‘,” or ;" before ‘double’
‘numeric_limits’ is not a member of ‘std’
expected primary-expression before ‘double’
: expected ‘;’ or ;’ before ‘double’

/home/giovanni/QGIS-Issue_8725-OGR/src/core/qgsmaprequest.cpp:135:5: error: X’ was not declared in this scope

/home/giovanni/QGIS-Issue_8725-OGR/src/core/qgsmaprequest.cpp:136:5: error: 'y’ was not declared in this scope

/home/giovanni/QGIS-Issue_8725-OGR/src/core/qgsmaprequest.cpp: At global scope:

/home/giovanni/QGIS-Issue_8725-OGR/src/core/qgsmaprequest.cpp:149:20: warning: unused parameter ‘sourceWkb’ [-Wunused-parameter]

make[2]: [ 14%)] *** [src/core/CMakeFiles/qgis_core.dir/qgsmaprequest.cpp.o] Error 1

make[2]: *** Waiting for unfinished jobs....

Building CXX object src/core/CMakeFiles/qgis_core.dir/ggsmaplayerregistry.cpp.o

make[1]: *** [src/core/CMakeFiles/qgis_core.dir/all] Error 2

make: *** [all] Error 2

#16 - 2013-10-22 05:14 AM - Alvaro Huarte

Hi Giovanni, | use Visual Studio 2010 and | don't get these errors.
What compiler do you use ?

I will try fix it!

#17 - 2013-10-22 05:17 AM - Giovanni Manghi

Alvaro Huarte wrote:
Hi Giovanni, | use Visual Studio 2010 and | don't get these errors.

What compiler do you use ?

1 will try fix it!

Hi Alvaro, | use Ubuntu Linux, gcc 4.6.3

#18 - 2013-10-22 05:19 AM - Matthias Kuhn

It's probably a simple #include <limits.h>

#19 - 2013-10-22 05:25 AM - Alvaro Huarte

Done, thanks!

#20 - 2013-10-23 07:39 AM - Giovanni Manghi

Alvaro Huarte wrote:

Done, thanks!

Hi Alvaro! | made a few quick tests with shapefiles, measuring just the time to open them (with the "time" command). | have not had the time to try evaluate

the improvement when zooming in/out.

The shapefiles (polygons) that | tested are:

http://faunalia.pt/downloads/GTBs_Shapefile.zip
http://faunalia.pt/downloads/MAMMTERR.zip

un-patched QGIS

giovanni@sibirica ~/Desktop $ time qgis MAMMTERR.shp
user 0m10.377s

user 0m10.237s

user 0m10.429s

giovanni@sibirica ~/Desktop $ time qgis GTBs_2011.shp
user 1m2.896s

user 1m5.436s

user 1m4.120s

patched QGIS

giovanni@sibirica ~/Desktop $ time qgis MAMMTERR.shp

user 0m6.352s
user 0m6.244s
user 0m6.820s

giovanni@sibirica ~/Desktop $ time qgis GTBs_2011.shp
user 0m35.278s

user 0m33.286s

user 0m33.602s

So there is really a substantial improvement!

| tested also another shape (big, more that 1.2gb of small polygons) where things get worst(?)

http://www.igeo.pt/scrif/crif CRIF2011shp.zip

unpatched

giovanni@sibirica ~/Desktop $ time qgis crif2011.shp
user  0m35.186s

user 0m34.870s

user 0m35.214s

patched

giovanni@sibirica ~/Desktop $ time qgis crif2011.shp
user 0m45.571s

user 0m49.311s

user 0m46.279s

Can | test also the vectors you are using to check the rendering times?

Cheers!

#21 - 2013-10-23 08:47 AM - Alvaro Huarte

Hi Giovanni, Some shapes...

http://idena.navarra.es/descargas/CARTO1_Lin_6CNivelD.zip

http://idena.navarra.es/descargas/GEOLOG_Pol_Litologia.zip

| am going to test your shapes!
Thanks!

#22 - 2013-10-23 11:30 PM - Matthias Kuhn

Running a rendering performance test once may be strongly biased by other processes running.
For statistically more robust numbers | recommend using qgis_bench

It's really simple to use.
Here some more information:

https://github.com/qgis/QGIS/blob/master/tests/bench/README

#23 - 2013-10-24 06:44 AM - Alvaro Huarte

Hi, | made tests with 'qgis_bench' to see the speed.

Soft/hard: WindowsXP+SP3, 32bits, 4gb RAM.

My shapefiles tested:

of navarra (Polygon2D of
142680 records, 66mb)

Dataset Value Master Patched
http://faunalia.pt/downloads | iterations 10 10 100%
/GTBs_Shapefile.zip

total_avg 180.1015625 68.8765625 38%
total_max 185.8125 71.484375 38%
total_maxdev 33.3046875 2.60781249999999 7%
total_min 146.796875 67.265625 45%
total_stdev 11.1268459888756 1.27757571479394 11%
http://faunalia.pt/downloads | iterations 10 10 100%
/MAMMTERR:.zip
total_avg 88.621875 9.49375 10%
total_max 95.09375 10 10%
total_maxdev 53.85625 1.665625 3%
total_min 34.765625 7.828125 22%
total_stdev 17.9542520316393 0.572148158805916 3%
http://www.igeo.pt/scrif/crif/ | iterations 10 10 100%
CRIF2011shp.zip
total_avg 275.1109375 70.275 25%
total_max 286.5625 71.4375 24%
total_maxdev 93.3609375 6.50937500000001 6%
total_min 181.75 63.765625 35%
total_stdev 31.1253721504484 2.18250769614909 7%
http://idena.navarra.es/desc | iterations 10 10 100%
argas/CARTO1_Lin_6CNiv
elD.zip
total_avg 8.2765625 1.4703125 17%
total_max 8.90625 1.515625 17%
total_maxdev 4.9796875 0.1109375 2%
total_min 3.296875 1.359375 41%
total_stdev 1.66037296379646 0.0578125 3%
http://idena.navarra.es/desc | iterations 10 10 100%
argas/GEOLOG_Pol_Litolo
gia.zip
total_avg 10.371875 1.7953125 17%
total_max 11.03125 1.859375 16%
total_maxdev 5.79375 0.4984375 8%
total_min 4.578125 1.296875 28%
total_stdev 1.93128792438492 0.166455758480294 8%
Urban parcels of cadastre | iterations 10 10 100%

2025-04-26

7/50



https://github.com/qgis/QGIS/blob/master/tests/bench/README

total_avg 8.6046875 3.3484375 38%
total_max 9.0625 3.375 37%
total_maxdev 2.9953125 0.1296875 4%
total_min 5.609375 3.21875 57%
total_stdev 0.999488394520542 0.0458481273472538 4%
Rustic parcels of cadastre |iterations 10 10 100%
of navarra (Polygon2D of
542658 records, 458mb)
total_avg 57.8265625 12.6921875 21%
total_max 61.859375 13.03125 21%
total_maxdev 28.4671875 0.957812499999999 3%
total_min 29.359375 11.734375 39%
total_stdev 9.50177422268632 0.32983557101418 3%

#24 - 2013-10-24 06:48 AM - Nathan Woodrow

Nice!

#25 - 2013-10-24 09:10 AM - Alvaro Huarte

- File sketch.png added

#26 - 2013-10-24 03:25 PM - Giovanni Manghi

Alvaro Huarte wrote:

I thought a bit :-), | think more appropriate to add a new "rendering” tab with this configuration similar to global options form.

| agree

#27 - 2013-10-24 03:26 PM - Giovanni Manghi

Alvaro Huarte wrote:

Hi, I made tests with 'qgis_bench' to see the speed.

Soft/hard: WindowsXP+SP3, 32bits, 4gb RAM.

very nice results indeed! as soon as | will understand how to use qgis_bench | will make tests too :)

#28 - 2013-10-24 09:53 PM - Alvaro Huarte

Hi Giovanni, qgis_bench is easy :-)

| execute in a Console Window (CMD)...

{%BIN_PATH%]}/qgis_bench -i 10 -p test_project.qgs >> test_project.log
-i- number of desired iterations

-p: project to test

Regards

#29 - 2013-10-26 09:24 AM - Giovanni Manghi

Alvaro Huarte wrote:

Hi Giovanni, qgis_bench is easy :-)

I execute in a Console Window (CMD,)...

{%BIN_PATH%}/qgis_bench -i 10 -p test_project.qgs >> test_project.log

-i: number of desired iterations

-p: project to test

Regards

| made also tests with qgis_bench

Dataset Value Master Patched
http://faunalia.pt/downloads | iterations 10 10 100%
/MAMMTERR:.zip

total_avg 14.6881179 3.616626 24%
total_max 15.500969 3.816239 24%
total_maxdev 2.3073439 0.204413 8%
total_min 12.380774 3.412213 27%
total_stdev 0.808622095655375 0.108486504445484 13%
http://faunalia.pt/downloads | iterations 10 10 100%
/GTBs_Shapefile.zip
total_avg 41.0249639 32.6264391 79%
total_max 42.986687 37.038314 86%
total_maxdev 1.9617231 4.41187489999999 224%
total_min 39.566472 30.029877 75%
total_stdev 1.12526313538864 1.95203781571303 173%
http://www.igeo.pt/scrif/crif/ | iterations 10 10 100%
CRIF2011shp.zip
total_avg 64.6020374 37.1403211 57%
total_max 65.808114 38.874429 59%
total_maxdev 4.3062684 2.76617309999999 64%
total_min 60.295769 34.374148 57%
total_stdev 1.54006099425576 1.13227893163129 73%

#30 - 2013-10-26 11:01 AM - Jiirgen Fischer
- Subject changed from Speed improvement in the render of geometries for qgis to Speed improvement in the render of geometries for qgis

#31 - 2013-10-26 01:30 PM - Alvaro Huarte
- File cfgimage.jpg added
Hi,

| have implemented a new tab called 'Rendering' in the options form of the layer where the user can configure the drawing simplification.

(} Layer Properties - municipio

Regards

#32 - 2013-10-26 03:15 PM - Giovanni Manghi

Alvaro Huarte wrote:

Hi,

I have implemented a new tab called ‘Rendering’ in the options form of the layer where the user can configure the drawing simplification.
(} Layer Properties - municipio E 2|
B Rendering
& General

F: 3| Fast drawing

< style
‘Z" ty Mote: This option enables geometry simplification drawing for fast rendering of the layer.
-E'_TFl Labels Simplification factor {Higher value draws more simplified geometries): O:'
?I L
..-i:_.i_'_! Fields
{ Rendering
| Display

. Actions
ili!(; Joins

1=l
|—!' Diagrams

@ Metadata

! Restore Default Style | i Save As Default | i Load Style ... i | Save Style % |

Regards

Hi Alvaro,

this means that when loading a layer the user will not see any improvement, isn't it? If yes then it is a pity because for large vectors there is also a huge
improvement when loading the layer. What about an option in the general qgis options and then the switch in vector properties to allow override the
general configuration?

#33 - 2013-10-26 03:40 PM - Alvaro Huarte

Hi Giovanni,

| propose that by default the simplification is activated (The check-box, by default, will be checked), after the user can disable it for some reason, so | have
been asked several people.

About a general option, | agree, but | do not what others think about it.

Giovanni, thank you very much for your tests and support!

Regards

#34 - 2013-10-27 02:46 AM - Jukka Rahkonen

Hi,

This may be a stupid question, but how does the simplified rendering work when users start to edit vectors? | think that users can not be let to edit those
features which are simplified for fast viewing and save edits back to the source shapefile. And what gets saved if used does not edit anything but wants to
make a copy by Save as..? Is QGIS saving the simpified layer of can is somehow handle two sort of geometries, the real ones and those temporarily

simplified for viewing? Even when other layers are edited the result might be unexpected if user wants to snap vertices of the layer that is edited to vertices
of the layer that is rendered as simplified.
#35 - 2013-10-27 11:13 AM - Alvaro Huarte

Hi @jratike80, this is a good question!, but there is not problem.

The simplification only is applied in the 'getFeatures' request when it becomes from a rendering request (... drawing the layer in the map). Fetch

geometries, update geometries... are executed using distinct 'getFeatures' requests where the geometries are fetched without simplification.

Regards

#36 - 2013-10-27 11:35 AM - Jiirgen Fischer
Alvaro Huarte wrote:
The simplification only is applied in the 'getFeatures’ request when it becomes from a rendering request (... drawing the layer in the map). Fetch
geometries, update geometries... are executed using distinct ‘getFeatures’ requests where the geometries are fetched without simplification.
You could also combine that with the QgsVectorLayer::isEditable() method - the layer does caching in edit mode. Another potential thing to look at is
snapping.
Other things to consider are unaligned accesses. Marco Bernasocchi is currently working in qgis/QGIS-Android on cleaning the code from unaligned
accesses (mainly when parsing or construction WKB; ARM doesn't like those), which is basically replacing all occurrences of *foo = bar; with memcpy(foo,
&bar, sizeof bar);. | see that you're introducing more of those. Please rework it to use memcpy.

And finally run the stuff through scripts/prepare-commit.sh (or scripts/astyle.sh for already committed stuff).

But enough whining - otherwise it's very nice work - thank you very much :)

#37 - 2013-10-27 05:22 PM - Alvaro Huarte

Hello Jurgen, thank you very much for your comments!

| have released new commits for the branch https:/github.com/ahuarte47/QGIS/compare/Issue_8725-OGR where | replace all “foo = bar' with 'memcpy".

This has been a lesson for me.

Also | disable the drawing simplification in 'editmode’, the geometries are cached for snapping, thanks.

About the scripts, | am going to study

Regards

#38 - 2013-10-29 03:25 AM - Alvaro Huarte

Hi Jargen,

After a failed performance test | wanted to do (https:/github.com/qgis/QGIS/pull/927#issuecomment-27158451), | retake his message referring to scripts.

| do not know very well how execute it. | must use cygwin ?

Thank you very much

2025-04-26 12/50


https://github.com/ahuarte47/QGIS/compare/Issue_8725-OGR
https://github.com/qgis/QGIS/pull/927#issuecomment-27158451

#39 - 2013-10-30 03:49 AM - Alvaro Huarte

To avoid confusion | created a new pull request with the last code.

New pull request:
https://github.com/qgis/QGIS/pull/980

Obsolete pull:
https://github.com/qgis/QGIS/pull/927

Regards

#40 - 2013-10-31 09:00 PM - Nathan Woodrow

Hey Alvaro,

Really like your work.

| seem to be having a small issue with the build though. When ever | run it in normal mode e.g just running the output qgis.exe file | get a crash as some as
| open the file or one feature renders. But - and here is the fun part - attach the debugger and | don't get a crash :)

Running qgis_bench has the same effect, just crashes. Very strange.

Nathan

#41 - 2013-11-01 12:42 AM - Alvaro Huarte

Hi Nathan, thanks for your comments!

| have test some shapes and all works fine in 'release’ build.
Can | test your data ?

Regards

#42 - 2013-11-01 01:56 AM - Alexander Bruy

Nathan Woodrow wrote:

| seem to be having a small issue with the build though. When ever I run it in normal mode e.g just running the output qgis.exe file | get a crash as
some as | open the file or one feature renders. But - and here is the fun part - attach the debugger and | don't get a crash :)

Same here. | can reproduce this with polygon layers. Lines and points opened correctly. Also | found that QGIS compiled from old branch (
https://github.com/qgis/QGIS/pull/927) works fine.

#43 - 2013-11-01 01:57 AM - Alexander Bruy
- Resolution deleted (fixed/implemented)
#44 - 2013-11-01 02:42 AM - Marco Hugentobler
I've done some tests with the patch, and | have mixed feelings towards applying. The optimisation has most effect in zoomed-out situations where the data
is too dense for the scale. But then, the user will still perceive it as slow performance (e.g. rendering 10 or 20 seconds without feedback is still slow). In
situations where the data is appropriate for the scale, the differences are very small. On the other side, the patch adds a lot of code and still has potential to
cause bugs (e.g. exporting in the composer with low resolution, say 50 dpi, shows gaps in a polygon mosaic).
#45 - 2013-11-01 02:58 AM - Giovanni Manghi
Marco Hugentobler wrote:
I've done some tests with the patch, and | have mixed feelings towards applying. The optimisation has most effect in zoomed-out situations where
the data is too dense for the scale. But then, the user will still perceive it as slow performance (e.g. rendering 10 or 20 seconds without feedback is

still slow). In situations where the data is appropriate for the scale, the differences are very small. On the other side, the patch adds a lot of code and

still has potential to cause bugs (e.g. exporting in the composer with low resolution, say 50 dpi, shows gaps in a polygon mosaic).
Hi,
speaking as a user here. We all know that rendering performances of large vectors are poor in QGIS when compared to other packages, so | really hope
that things can be sorted out. Is for this reason that | asked for a Windows installer that includes the patch (Alex is working on it, thanks!), to allow people

test the patch, eventually find the issues and so allow you devs to eventually fix them.

By the way, loading time of large vectors is much better with the patch, this itself is a very welcome improvement.

#46 - 2013-11-01 03:37 AM - Nathan Woodrow

Marco Hugentobler wrote:
I've done some tests with the patch, and | have mixed feelings towards applying. The optimisation has most effect in zoomed-out situations where
the data is too dense for the scale. But then, the user will still perceive it as slow performance (e.g. rendering 10 or 20 seconds without feedback is

still slow). In situations where the data is appropriate for the scale, the differences are very small. On the other side, the patch adds a lot of code and

still has potential to cause bugs (e.g. exporting in the composer with low resolution, say 50 dpi, shows gaps in a polygon mosaic).

The rendering at large scales is the main issue most people have with large datasets so this is where you need the most performance gain which this patch
seems to achieve. When you are at smaller scales you don't have as many geometries so normally QGIS handles things well. Some of my clients have
pretty large datasets and this is a major issue for them.

Regarding exporting in the composer | would suggest just turning it off at that point and render with the full geometries. Navigating the map is what most
people do and printing is normally expected to not be a super quick operation. It should be as fast as possible but if | have to wait 1 minute to get correct

results in a print out | will happily, however I'm not going to wait a minute for my screen to render while | am building a map or editing.

IMO this needs to be considered. Not saying it should be merged today, or even next week but | think it's a worthwhile patch. As long as there is a way to
switch it off, even as a build time option in case something really bad comes up then | think that would be fine.

Couple this kind of thing with the multithreading and we should see a nice boost in the rendering speed.

#47 - 2013-11-01 03:40 AM - Alvaro Huarte
Giovanni Manghi wrote:

Marco Hugentobler wrote:

I've done some tests with the patch, and | have mixed feelings towards applying. The optimisation has most effect in zoomed-out situations where
the data is too dense for the scale. But then, the user will still perceive it as slow performance (e.g. rendering 10 or 20 seconds without feedback is
still slow). In situations where the data is appropriate for the scale, the differences are very small. On the other side, the patch adds a lot of code

and still has potential to cause bugs (e.g. exporting in the composer with low resolution, say 50 dpi, shows gaps in a polygon mosaic).
Hi,
speaking as a user here. We all know that rendering performances of large vectors are poor in QGIS when compared to other packages, so I really

hope that things can be sorted out. Is for this reason that | asked for a Windows installer that includes the patch (Alex is working on it, thanks!), to

allow people test the patch, eventually find the issues and so allow you devs to eventually fix them.

By the way, loading time of large vectors is much better with the patch, this itself is a very welcome improvement.

Hi, I am working for build a windows installer with this patch.

I build the default installer with the script 'creatensis.pl' but it does not contains my patch. | must study how insert it.

#48 - 2013-11-01 03:41 AM - Matthias Kuhn

Hi Alvaro,

The effect of disabled anti-aliasing is still perceptible here.
Which portion of the performance is gained by disabling AA actually?

The upper part is rendered without the patch, the lower part with the patch.

http://i.imgur.com/oy60uTa.png

#49 - 2013-11-01 03:48 AM - Alvaro Huarte

Alexander Bruy wrote:

Nathan Woodrow wrote:

| seem to be having a small issue with the build though. When ever | run it in normal mode e.g just running the output qgis.exe file | get a crash as
some as | open the file or one feature renders. But - and here is the fun part - attach the debugger and | don't get a crash :)

Same here. | can reproduce this with polygon layers. Lines and points opened correctly. Also | found that QGIS compiled from old branch (
https://github.com/qgis/QGIS/pull/927) works fine.

I must study it, the code is the same but in last commit | also did a merge with master branch for make the windows installer.

#50 - 2013-11-01 03:57 AM - Alvaro Huarte

Nathan Woodrow wrote:
Marco Hugentobler wrote:

I've done some tests with the patch, and | have mixed feelings towards applying. The optimisation has most effect in zoomed-out situations where
the data is too dense for the scale. But then, the user will still perceive it as slow performance (e.g. rendering 10 or 20 seconds without feedback is
still slow). In situations where the data is appropriate for the scale, the differences are very small. On the other side, the patch adds a lot of code

and still has potential to cause bugs (e.g. exporting in the composer with low resolution, say 50 dpi, shows gaps in a polygon mosaic).

The rendering at large scales is the main issue most people have with large datasets so this is where you need the most performance gain which
this patch seems to achieve. When you are at smaller scales you don't have as many geometries so normally QGIS handles things well. Some of
my clients have pretty large datasets and this is a major issue for them.

Regarding exporting in the composer | would suggest just turning it off at that point and render with the full geometries. Navigating the map is what
most people do and printing is normally expected to not be a super quick operation. It should be as fast as possible but if | have to wait 1 minute to

get correct results in a print out | will happily, however I'm not going to wait a minute for my screen to render while | am building a map or editing.

IMO this needs to be considered. Not saying it should be merged today, or even next week but | think it's a worthwhile patch. As long as there is a

way to switch it off, even as a build time option in case something really bad comes up then | think that would be fine.

Couple this kind of thing with the multithreading and we should see a nice boost in the rendering speed.

| agree, this patch improves the 'rendering at large scales', for getting rendering feedback the user can enable this existing option in the global options form
of qgis.

To avoid problems in composer | am going disable this patch in 'printing' tasks.

Also, at least windows, there is other important improvement that | want test: Support for 'FileMapping' in the gdal-ogr library (e.g. using boost library) for
speed up the access to data. | have experience with it and can be 2x faster.

#51 - 2013-11-01 05:52 AM - Giovanni Manghi

Nathan Woodrow wrote:

The rendering at large scales is the main issue most people have with large datasets so this is where you need the most performance gain which
this patch seems to achieve. When you are at smaller scales you don't have as many geometries so normally QGIS handles things well. Some of
my clients have pretty large datasets and this is a major issue for them.

Regarding exporting in the composer | would suggest just turning it off at that point and render with the full geometries. Navigating the map is what
most people do and printing is normally expected to not be a super quick operation. It should be as fast as possible but if | have to wait 1 minute to

get correct results in a print out | will happily, however I'm not going to wait a minute for my screen to render while | am building a map or editing.

IMO this needs to be considered. Not saying it should be merged today, or even next week but | think it's a worthwhile patch. As long as there is a
way to switch it off, even as a build time option in case something really bad comes up then | think that would be fine.

Couple this kind of thing with the multithreading and we should see a nice boost in the rendering speed.

+1

#52 - 2013-11-01 08:59 AM - Alvaro Huarte
Matthias Kuhn wrote:

Hi Alvaro,

The effect of disabled anti-aliasing is still perceptible here.
Which portion of the performance is gained by disabling AA actually?

The upper part is rendered without the patch, the lower part with the patch.

http://i.imgur.com/oy60uTa.png

Hi Matthias, disable antialiasing for far geometries is perceptible, but for large datasets it save rendering time (I will make tests with some shapes and send
results). ArcGis, by example, also cheats with that. | think that is more important to get fast framerates that high quality rendering, But, of course, all people

has one opinion, | do what seems best to the community.

regards

#53 - 2013-11-01 09:47 AM - Alvaro Huarte

Hi Matthias, we have another think coming, :-)

A few days ago, you said me... "... another minor thing is, that the simplification code should probably not be in the request, but rather in the place where the

simplification is done, so in the iterator or rather in its own simplification class (maybe other parts of the code need it...)".

Still think the same? | have no problem in creating a new utility class that implements this simplification code as static methods.

Thanks for your recommendations.

#54 - 2013-11-01 04:46 PM - Nyall Dawson
Nathan Woodrow wrote:
The rendering at large scales is the main issue most people have with large datasets so this is where you need the most performance gain which

this patch seems to achieve. When you are at smaller scales you don't have as many geometries so normally QGIS handles things well. Some of

my clients have pretty large datasets and this is a major issue for them.

Sorry to nitpick, but just for clarification - are you actually meaning rendering at small scales (further zoomed out) is where the performance gain is? If so, |
agree that this is a significant issue which would be great to address.
#55 - 2013-11-01 04:50 PM - Nathan Woodrow
Nyall Dawson wrote:
Nathan Woodrow wrote:
The rendering at large scales is the main issue most people have with large datasets so this is where you need the most performance gain which

this patch seems to achieve. When you are at smaller scales you don't have as many geometries so normally QGIS handles things well. Some of

my clients have pretty large datasets and this is a major issue for them.
Sorry to nitpick, but just for clarification - are you actually meaning rendering at small scales (further zoomed out) is where the performance gain is?

If so, | agree that this is a significant issue which would be great to address.

Yeah. Just stuffed up my terms.

#56 - 2013-11-01 11:40 PM - Nyall Dawson

Ok - in that case | run into this same issue almost daily, and any improvements would be greatly appreciated!

#57 - 2013-11-02 02:19 PM - Alvaro Huarte

Nyall Dawson wrote:

Ok - in that case I run into this same issue almost daily, and any improvements would be greatly appreciated!

| hope that with this patch, and the improvement of "FileMapping" | want to add to gdal-ogr providers, it result a very good behavior of qgis for render large

datasets.

Best regards

#58 - 2013-11-02 03:46 PM - Alvaro Huarte

Alvaro Huarte wrote:

Alexander Bruy wrote:

Nathan Woodrow wrote:

| seem to be having a small issue with the build though. When ever I run it in normal mode e.g just running the output qgis.exe file | get a crash as

some as | open the file or one feature renders. But - and here is the fun part - attach the debugger and | don't get a crash :)

Same here. | can reproduce this with polygon layers. Lines and points opened correctly. Also | found that QGIS compiled from old branch (
https.//github.com/qqis/QGIS/pull/927) works fine.

I must study it, the code is the same but in last commit | also did a merge with master branch for make the windows installer.

| have reverted the last commit with the merge action.

| hope that it fix this build issue.

#59 - 2013-11-03 04:00 PM - Alvaro Huarte

Matthias Kuhn wrote:

Hi Alvaro,

The effect of disabled anti-aliasing is still perceptible here.
Which portion of the performance is gained by disabling AA actually?

The upper part is rendered without the patch, the lower part with the patch.

http://i.imgur.com/oy60uTa.png

Hi, | have tests with 'qgis_bench' to see the improvement disabling 'AA' for '1-pixel geometries'.

Soft/hard: WindowsXP+SP3, 32bits, 4gb RAM.

- Patched (1): Disable 'AntiAliasing' for '1-pixel geometries' is not executed.
- Patched (2): Disable 'AntiAliasing' for '1-pixel geometries' is executed.

My shapefiles tested:

Datas | Value | Maste | Patch | (1-0) | Patch | (2-0) | (2-1)
et r(0) |ed(1) ed (2)

http:/f |iteratio [ 10 10 10

aunalia|ns

.pt/dow

nloads

/GTBs

_Shap

efile.zi

p
total_a [211,02 (87,792 |42% |86,057 |41% |2%
vg 344 |19 81
total_m| 224,60 [ 89,625 88,187
ax 938 00 50
total_m| 30,398 | 1,8328 2,1296
axdev |44 1 9
total_m| 180,62 | 86,812 84,031
in 500 50 25
total_s | 11,062 | 0,8666 1,3585
tdev 05 5 5

http:/f |iteratio [ 10 10 10

aunalia|ns

.pt/dow

nloads

/MAMM

TERR.

zip
total_a [ 84,651 (12,434 15% [10,985|13% |12%
vg 56 38 94
total_m| 92,843 [ 15,546 11,375
ax 75 88 00
total_m| 52,214 3,1125 1,5015
axdev |06 0 6
total_m| 32,437 11,937 9,4843
in 50 50 8
total_s | 17,425 [ 1,0449 0,5136
tdev 08 3 5
http://w| iteratio | 10 10 10

ww.ige | ns

o.pt/sc

rif/crif/

CRIF2

011sh

p.zip
total_a [247,60|109,75|44% [77,251|31% |30%
vg 625 469 56
total_m| 257,84 | 112,65 85,671
ax 375 625 88
total_m| 74,059 16,973 8,4203
axdev |38 44 1
total_m| 173,54 | 92,781 74,734
in 688 25 38
total_s [ 24,700 5,6721 3,3056
tdev |81 5 0

http://id| iteratio | 10 10 10

ena.na |ns

varra.e

s/desc

argas/

CART

O1_Lin

_6CNi

velD.zi

p
total_a | 7,8578|1,9484 | 25% [1,5843|20% |19%
vg 1 4 8
total_m| 8,4062 | 2,8593 2,3281
ax 5 8 3
total_m| 4,5453|0,9109 0,7437 total_m| 3,3125| 1,8281 1,4531
axdev |1 4 5 in 0 3 3
total_s [ 1,5153|0,3041 0,2499
tdev 7 1 2

http://id| iteratio | 10 10 10

ena.na |ns

varra.e

s/desc

argas/

GEOL

OG_P

ol_Lito

logia.z

ip
total_a [9,3140|2,1906 | 24% [2,0375|22% |7%
vg 6 3 0
total_m| 10,062 | 3,0781 3,1250
ax 50 3 0
total_m| 4,8453|0,8875 1,0875
axdev |1 0 0
total_m| 4,4687 | 2,0625 1,8906
in 5 0 3
total_s | 1,6186 | 0,2960 0,3630
tdev |2 3 4

Urban |iteratio [ 10 10 10

parcels|ns

of

cadast

re of

navarr

a

(Polyg

on2D

of

14268

0

record

S,

66mb)
total_a | 8,2015(5,3000 | 65% [3,7593|46% [29%
vg 6 0 8
total_m| 8,6250 | 5,5468 3,8281
ax 0 8 3
total_m| 3,0609 | 1,5187 0,1500 total_m| 5,1406 | 3,7812 3,6093
axdev |4 5 0 in 3 5 8
total_s [ 1,0210 | 0,5074 0,0589
tdev 1 5 6

Rustic [iteratio | 10 10 10

parcels|ns

of

cadast

re of

navarr

a

(Polyg

on2D

of

47265

8

record

S,

458mb

)
total_a (43,417 (16,492 |38% |11,770|27% |29%
vg 19 19 31
total_m| 46,250 [ 17,234 12,046
ax 00 38 88
total_m| 24,573 [ 0,7421 0,7859
axdev |44 9 4
total_m| 18,843 [ 16,328 10,984
in 75 13 38
total_s | 8,1914 | 0,2561 0,2720
tdev 1 0 8

| think that disable 'AA' for far geometries is effective, but it is true that, by contrast, a lower visual quality is perceptible especially for maps with geometries
isolated.
| think it's worth apply it.
Regards
#60 - 2013-11-04 02:25 AM - Matthias Kuhn
Thank you for this nice table.
So, disabling AA indeed seems to result in a noticeable difference in some cases.
| would prefer to make it an optional feature the way it looks. | have seen you committed something related to AA, was this a new config option?
#61 - 2013-11-04 03:00 AM - Alvaro Huarte
Matthias Kuhn wrote:
Thank you for this nice table.
So, disabling AA indeed seems to result in a noticeable difference in some cases.
| would prefer to make it an optional feature the way it looks. | have seen you committed something related to AA, was this a new config option?
Hi Matthias,

It is very appreciable when the layer is very dense with a lot of small geometries.

Referred to the last commit, | was pending disable 'AA’ for '1-pixel geometries' only when the simplification of the layer is activated. Temporal

'QgsSymbolV2RenderContext' objects created in 'QgsSymbolV2' class lose its 'VectorLayer' owner, and | have fixed it.

Referred to append a new extra option for disable the 'AA' of far geometries, | think that if the user already active the 'Fast drawing' implicitly assumes that

the drawing quality can be a bit lower. | think that add other option can be strange or too complex to "understand”. But | accept that the community send me

)

Best regards

#62 - 2013-11-04 03:11 AM - Regis Haubourg

Referred to append a new extra option for disable the 'AA’ of far geometries, | think that if the user already active the 'Fast drawing' implicitly
assumes that the drawing quality can be a bit lower. | think that add other option can be strange or too complex to "understand". But | accept that the

community send me :-)

Hi Alvaro,

In fact, if AA is enabled, symboly will be altered since you can't use symbols smaller than 1 pixel. So user will have to recalibrate symbology with your
option for existing projects. We should avoid that. One big point with QGIS is precisely AA rendering, and we must keep antialising enabled. If user wants a
Mapinfo-Arcgis style, faster, AA option is already there in general options, and user should gain your speed improvements + AA-OFF improvement.

My two cents, Régis

#63 - 2013-11-04 03:31 AM - Alvaro Huarte

regis Haubourg wrote:
Referred to append a new extra option for disable the 'AA’ of far geometries, | think that if the user already active the 'Fast drawing' implicitly
assumes that the drawing quality can be a bit lower. | think that add other option can be strange or too complex to "understand". But | accept that

the community send me :-)

Hi Alexandro,

In fact, if AA is enabled, symboly will be altered since you can't use symbols smaller than 1 pixel. So user will have to recalibrate symbology with
your option for existing projects. We should avoid that. One big point with QGIS is precisely AA rendering, and we must keep antialising enabled. If
user wants a Mapinfo-Arcgis style, faster, AA option is already there in general options, and user should gain your speed improvements + AA-OFF

improvement.

My two cents, Régis

Hi, I don't understand your reply very well, :-)

| may not have described right this behavior:

The 'AA' is only individually disabled for geometries of a layer so far that it fill a '1-pixel' of the map, the rest are painted using the 'AA' option as heretofore.

#64 - 2013-11-04 07:25 AM - Alvaro Huarte

Alvaro Huarte wrote:

Nathan Woodrow wrote:

Marco Hugentobler wrote:

I've done some tests with the patch, and | have mixed feelings towards applying. The optimisation has most effect in zoomed-out situations
where the data is too dense for the scale. But then, the user will still perceive it as slow performance (e.g. rendering 10 or 20 seconds without
feedback is still slow). In situations where the data is appropriate for the scale, the differences are very small. On the other side, the patch adds a
lot of code and still has potential to cause bugs (e.g. exporting in the composer with low resolution, say 50 dpi, shows gaps in a polygon

mosaic).

The rendering at large scales is the main issue most people have with large datasets so this is where you need the most performance gain which
this patch seems to achieve. When you are at smaller scales you don't have as many geometries so normally QGIS handles things well. Some of

my clients have pretty large datasets and this is a major issue for them.

Regarding exporting in the composer | would suggest just turning it off at that point and render with the full geometries. Navigating the map is what
most people do and printing is normally expected to not be a super quick operation. It should be as fast as possible but if | have to wait 1 minute to
get correct results in a print out | will happily, however I'm not going to wait a minute for my screen to render while | am building a map or editing.

IMO this needs to be considered. Not saying it should be merged today, or even next week but | think it's a worthwhile patch. As long as there is a

way to switch it off, even as a build time option in case something really bad comes up then | think that would be fine.

Couple this kind of thing with the multithreading and we should see a nice boost in the rendering speed.

| agree, this patch improves the ‘rendering at large scales', for getting rendering feedback the user can enable this existing option in the global

options form of qgis.

To avoid problems in composer | am going disable this patch in 'printing' tasks.

Also, at least windows, there is other important improvement that | want test: Support for ‘'FileMapping' in the gdal-ogr library (e.g. using boost

library) for speed up the access to data. | have experience with it and can be 2x faster.
Hi, the last commit disable the 'drawing simplification’ for print compositions.

Best regards

#65 - 2013-11-04 07:32 AM - Alvaro Huarte

Giovanni Manghi wrote:

Marco Hugentobler wrote:
I've done some tests with the patch, and | have mixed feelings towards applying. The optimisation has most effect in zoomed-out situations where
the data is too dense for the scale. But then, the user will still perceive it as slow performance (e.g. rendering 10 or 20 seconds without feedback is
still slow). In situations where the data is appropriate for the scale, the differences are very small. On the other side, the patch adds a lot of code
and still has potential to cause bugs (e.g. exporting in the composer with low resolution, say 50 dpi, shows gaps in a polygon mosaic).

Hi,

speaking as a user here. We all know that rendering performances of large vectors are poor in QGIS when compared to other packages, so I really

hope that things can be sorted out. Is for this reason that | asked for a Windows installer that includes the patch (Alex is working on it, thanks!), to

allow people test the patch, eventually find the issues and so allow you devs to eventually fix them.

By the way, loading time of large vectors is much better with the patch, this itself is a very welcome improvement.

Hi Giovanni, now | am going to make a Windows Installer with the current patch state.

Telling you as | have!

#66 - 2013-11-04 07:33 AM - Matthias Kuhn

Alvaro,

| can imagine to enable this functionality for screen rendering by default sooner or later, but only if all optimization are non-visible. (Sub-pixel simplification /
no AA)

On the other hand it seems, that there is the possibility to improve performance even further but at the expense of visible graphics quality degradation. This

can be ok for some situations / systems, but needs to be opt-in.

So | would welcome to have the two nicely separated already. Do you think this is a road we can take?

#67 - 2013-11-04 08:03 AM - Alvaro Huarte

Hi Matthias, | can add other option to the new 'fast drawing' box in the 'rendering' options panel for the 'AA-disabling' advising that it is possible a graphics

quality degradation.

If you like well | want to try before prepare the windows installer with this patch Giovanni asked for days.

#68 - 2013-11-04 09:18 AM - Giovanni Manghi

Hi Giovanni, now | am going to make a Windows Installer with the current patch state.
Telling you as I have!

thanks!

#69 - 2013-11-04 06:12 PM - Alvaro Huarte
Alvaro Huarte wrote:
Giovanni Manghi wrote:
Marco Hugentobler wrote:
I've done some tests with the patch, and | have mixed feelings towards applying. The optimisation has most effect in zoomed-out situations
where the data is too dense for the scale. But then, the user will still perceive it as slow performance (e.g. rendering 10 or 20 seconds without
feedback is still slow). In situations where the data is appropriate for the scale, the differences are very small. On the other side, the patch adds a
lot of code and still has potential to cause bugs (e.g. exporting in the composer with low resolution, say 50 dpi, shows gaps in a polygon
mosaic).
Hi,
speaking as a user here. We all know that rendering performances of large vectors are poor in QGIS when compared to other packages, so |
really hope that things can be sorted out. Is for this reason that | asked for a Windows installer that includes the patch (Alex is working on it,

thanks!), to allow people test the patch, eventually find the issues and so allow you devs to eventually fix them.

By the way, loading time of large vectors is much better with the patch, this itself is a very welcome improvement.

Hi Giovanni, now | am going to make a Windows Installer with the current patch state.

Telling you as | have!

Done:
http://www_filedropper.com/qgis-osgeo4w-210-f8725-setup-x86

It contains the Windows Installer with the qgis master branch + #8725 patch.

Regards

#70 - 2013-11-05 01:45 AM - Bo Victor Thomsen

Alvaro -

I've tried your patched version of QGIS. Works nicely with shape files and with large speed improvements. However, QGIS crashes when I'm trying to open

a Postgis based layer. Mini dump file available at: https://docs.google.com/file/d/0B_386CU-PnW0cndaZXZOT1FWM2c/edit?usp=docslist_api (It's
20MB)

The postgis layer works in "normal" master.
OS Version: Window 8.1

Regards Bo Victor Thomsen
#71 - 2013-11-05 02:43 AM - Giovanni Manghi

Bo Victor Thomsen wrote:

Alvaro -

I've tried your patched version of QGIS. Works nicely with shape files and with large speed improvements. However, QGIS crashes when I'm trying

to open a Postgis based layer. Mini dump file available at:
https.//docs.google.com/file/d/0B_386CU-PnW0cndaZXZOT1FWMZ2c/edit?usp=docslist_api (It's 20MB)

The postgis layer works in "normal” master.
OS Version: Window 8.1

Regards Bo Victor Thomsen

confirmed here

#72 - 2013-11-05 02:44 AM - Giovanni Manghi

Done:
http://www.filedropper.com/qqgis-osgeo4w-210-f8725-setup-x86

It contains the Windows Installer with the qgis master branch + #8725 patch.

Regards

Thanks! | will make some tests!

#73 - 2013-11-05 03:09 AM - Alvaro Huarte

Giovanni Manghi wrote:

Bo Victor Thomsen wrote:

Alvaro -

I've tried your patched version of QGIS. Works nicely with shape files and with large speed improvements. However, QGIS crashes when I'm trying

to open a Postgis based layer. Mini dump file available at:
https.//docs.google.com/file/d/0B_386CU-PnW0cndaZXZOT1FWMZ2c/edit ?usp=docslist_api (It's 20MB)

The postgis layer works in "normal” master.
OS Version: Window 8.1

Regards Bo Victor Thomsen

confirmed here

Sorry, now | don't have installed the dump debugging tools.

| have tested with some postgis layers and works fine for me.
The error is throw for all layers ?
Are you using the application compiled from my pull request, or from the windows installer ?
If it is throwed by one layer, can you send me as shapefile for test here ?

Anyway, at night at home, | will setup the dump debugging tools for test the error

Thanks for your support!

Note: The improvement is very perceptible?

Best Regards

#74 - 2013-11-05 03:37 AM - Alvaro Huarte

Matthias Kuhn wrote:

Alvaro,

I can imagine to enable this functionality for screen rendering by default sooner or later, but only if all optimization are non-visible. (Sub-pixel

simplification / no AA)

On the other hand it seems, that there is the possibility to improve performance even further but at the expense of visible graphics quality

degradation. This can be ok for some situations / systems, but needs to be opt-in.

So | would welcome to have the two nicely separated already. Do you think this is a road we can take?

Hi Matthias, according your advice, the last commit implements 'simplification hints' allowing configure what drawing simplification type can be executed
(Points, BBOX or AA, or any combination).

By default, the full simplification (Points+BBOX+AA) will be applied.

#75 - 2013-11-05 04:30 AM - andre mano

- Operating System set to Windows 7

- OS version set to 64bits

| tested with a shapefile containing 75k polygons and although | don't have a quantitative analysis, | can say that the rendering (even without going to
quality threshold) it's at least twice as fast as QGIS 2.0.

| repeated the test with another shapefile containing 1000000 + polygons and the loading and pan/zoom operations became fast enough to make this layer
usable in QGIS without loading it first into a spatial DB, specially if you give a high quality threshhold value.

A great add to QGIS!

#76 - 2013-11-05 05:45 AM - Giovanni Manghi

Note: The improvement is very perceptible?

yes:)
#77 - 2013-11-05 09:39 AM - Alvaro Huarte

Giovanni Manghi wrote:

Note: The improvement is very perceptible?

yes :)

| am delighted to read that.
| hope soon to add "FileMapping" support to gdal-ogr and when approved, another speed up for qgis!

#78 - 2013-11-05 09:40 AM - Alvaro Huarte

- Operating System deleted (Windows 7)

- OS version deleted (64bits)

Alvaro Huarte wrote:

Giovanni Manghi wrote:

Note: The improvement is very perceptible?

yes :)

| am delighted to read that.
| hope soon to add "FileMapping" support to gdal-ogr and when approved, another speed up for qgis!

#79 - 2013-11-05 06:22 PM - Alvaro Huarte

Bo Victor Thomsen wrote:

Alvaro -

I've tried your patched version of QGIS. Works nicely with shape files and with large speed improvements. However, QGIS crashes when I'm trying

to open a Postgis based layer. Mini dump file available at:
https://docs.google.com/file/d/0B_386CU-PnW0cndazZXZOT1FWMZ2c/edit?usp=docslist_api (It's 20MB)

The postgis layer works in "normal” master.
OS Version: Window 8.1

Regards Bo Victor Thomsen

Hello Bo Victor, you are right, ggis from my windows installer crashes when the user load a postgis layer.

But the error is not related with my patch code, the exception is thrown before load the layer in 'void QgsApplication::preNotify()' method when the 'add’

button of the configuration form is clicked.

| think this error is described in #5597-27.
In my compiled version | do not get that error so it has to be what files | have replaced in the master version of qgis for make the windows installer.

| must study it for rebuild the windows installer for test this patch.

Regards

#80 - 2013-11-05 10:12 PM - Bo Victor Thomsen

Alvaro -
Sorry for being late to the party, | was at a mapping conference. Just to answer your questions even though you seem to have found the error: QGIS
crashes just after I've selected one postgis table and clicked the "Add" button in the "PostGres add layer dialog".

Question no 2: The shape file (which works fine) has a speed improvement of 50%. The layer contains 1.300.000 polygon shapes and goes from 40 sec.
load to 20 sec. load on my Icore7 PC with SSD.
Regards

#81 - 2013-11-05 10:32 PM - Alvaro Huarte

Bo Victor Thomsen wrote:

Alvaro -

Sorry for being late to the party, | was at a mapping conference. Just to answer your questions even though you seem to have found the error: QGIS
crashes just after I've selected one postgis table and clicked the "Add" button in the "PostGres add layer dialog".

Question no 2: The shape file (which works fine) has a speed improvement of 50%. The layer contains 1.300.000 polygon shapes and goes from 40

sec. load to 20 sec. load on my Icore7 PC with SSD.
Regards

Hi,
This error is strange for me, and seems like an old error is back, Should | add a issue to the list of QGIS?

#82 - 2013-11-07 02:11 AM - Bo Victor Thomsen

Alvaro -

I've just tried the Postgis layer on the latest 32 bit QGIS Master and Current(2.0.1-3) installed with the Osgeo4w installer. They both worked without a
hitch. So the problem is isolated to the special install build of QGIS with the speed improvements. | don't think you should report it as a general QGIS
issue. Is it possible for you to zip the qgis.exe or maybe the "bin" directory of your working copy of the special QGIS and upload it somewhere | could get it?

Regards

#83 - 2013-11-08 04:33 AM - Alvaro Huarte

Bo Victor Thomsen wrote:

Alvaro -

I've just tried the Postgis layer on the latest 32 bit QGIS Master and Current(2.0.1-3) installed with the Osgeo4w installer. They both worked without
a hitch. So the problem is isolated to the special install build of QGIS with the speed improvements. | don't think you should report it as a general
QGIS issue. Is it possible for you to zip the qgis.exe or maybe the "bin" directory of your working copy of the special QGIS and upload it somewhere |

could get it?
Regards

Hi, thanks for your reply!

| found my error. Sorry, rookie mistake, | built the windows installer using the QGIS desktop distribution from the OSGeo4W setup, it is 2.0.X... all wrong.
| remade the installer from my master package and gives me no errors in the postgis loading form.

The new installer is (195mb):

http://www_filedropper.com/qgis-osgeo4w-210-f8725-setup-x86v20

Only bin folder (8mb):
http://www.filedropper.com/qgis-osgeo4w-210-f8725-bin-x86v20

Best Regards.

#84 - 2013-11-13 04:26 PM - Alvaro Huarte

Hi,

There is a bug in QgsOgrFeaturelterator::ensureRelevantFields(), the feature cursor always fetchs all attributes ignoring the relevant fields configuration of

the feature request.

| am trying to improve the OGR-GDAL provider and Even Rouault (gdal-dev) help me for find this bug (#9062).

commit:af73f30c fixes this in master!

In many cases the layers are required to be painted without any field, or one or two fields, therefore, other improvement for render vector layers!

Thanks for all!

Regards

#85 - 2013-11-13 04:31 PM - Giovanni Manghi

therefore, other improvement for render vector layers!

very good news!

any chance for an updated windows installer? | don't need it as | can compile on Linux, it is just to allow the many Windows user to keep testing your

(updated) work.

#86 - 2013-11-14 02:17 AM - Alvaro Huarte

Giovanni Manghi wrote:

therefore, other improvement for render vector layers!

very good news!
any chance for an updated windows installer? | don't need it as | can compile on Linux, it is just to allow the many Windows user to keep testing

your (updated) work.

Hi Giovanni, | prepare in brief.

Thanks for you support!

#87 - 2013-11-14 06:39 PM - Alvaro Huarte

Giovanni Manghi wrote:

therefore, other improvement for render vector layers!

very good news!

any chance for an updated windows installer? | don't need it as | can compile on Linux, it is just to allow the many Windows user to keep testing

your (updated) work.

Hi,

The new installer (195mb):
http://www.filedropper.com/qgis-osgeo4w-210-f8725-setup-x86v30

It also contains a proposed improvement in GDAL ( https://github.com/OSGeo/gdal/pull/26 ).

| hope to be accepted :-)

Note:
This installer does not contain any plugin of python, it is a subset of the QGIS 2.1 release for testing proposes.

Regards

#88 - 2013-11-15 10:01 AM - Giovanni Manghi

Hi Alvaro

with the new installer QGIS crashes when starting.

Cheers!

Alvaro Huarte wrote:

Giovanni Manghi wrote:

therefore, other improvement for render vector layers!

very good news!

any chance for an updated windows installer? | don't need it as | can compile on Linux, it is just to allow the many Windows user to keep testing

your (updated) work.

2025-04-26 31/50


http://www.filedropper.com/qgis-osgeo4w-210-f8725-setup-x86v30
https://github.com/OSGeo/gdal/pull/26

Hi,

The new installer (195mb):
http://www.filedropper.com/qqgis-osgeo4w-210-f8725-setup-x86v30

It also contains a proposed improvement in GDAL ( https.//qithub.com/OSGeo/gdal/pull/26 ).

I hope to be accepted :-)

Note:

This installer does not contain any plugin of python, it is a subset of the QGIS 2.1 release for testing proposes.

Regards

#89 - 2013-11-15 11:22 AM - Alvaro Huarte

Giovanni Manghi wrote:

Hi Alvaro

with the new installer QGIS crashes when starting.

Cheers!

Alvaro Huarte wrote:

Giovanni Manghi wrote:

therefore, other improvement for render vector layers!

very good news!

any chance for an updated windows installer? | don't need it as | can compile on Linux, it is just to allow the many Windows user to keep testing
your (updated) work.

Hi,

The new installer (195mb):
http.//www.filedropper.com/qqgis-osgeo4w-210-18725-setup-x86v30

It also contains a proposed improvement in GDAL ( https.//github.com/OSGeo/gdal/pull/26 ).

| hope to be accepted :-)

Note:

This installer does not contain any plugin of python, it is a subset of the QGIS 2.1 release for testing proposes.

Regards

Sorry, | can not rebuild well the installer, but it is independent of the changes I'm making.
| should download again all OSGeo4W packages.
| try shortly.

#90 - 2013-11-15 09:15 PM - Alvaro Huarte

Alvaro Huarte wrote:

Giovanni Manghi wrote:

Hi Alvaro

with the new installer QGIS crashes when starting.

Cheers!

Alvaro Huarte wrote:

Giovanni Manghi wrote:

therefore, other improvement for render vector layers!

very good news!

any chance for an updated windows installer? | don't need it as | can compile on Linux, it is just to allow the many Windows user to keep testing
your (updated) work.

Hi,

The new installer (195mb):
htto.//www.filedropper.com/qgis-osgeo4w-210-18725-setup-x86v30

It also contains a proposed improvement in GDAL ( https.//github.com/OSGeo/gdal/pull/26 ).

| hope to be accepted :-)

Note:

This installer does not contain any plugin of python, it is a subset of the QGIS 2.1 release for testing proposes.

Regards

Sorry, | can not rebuild well the installer, but it is independent of the changes I'm making.
| should download again all OSGeo4W packages.

I try shortly.

| have updated my OSGeo4W packages and | hope that new windows installer is fine.
http://www filedropper.com/qgis-osgeo4w-210-f8725-setup-x8640

Best Regards

#91 - 2013-11-16 03:42 AM - Bo Victor Thomsen
Hi Alvaro -

| just tried your new version of QGIS on my Postgis-based dataset (1.3 million buildings, i.e simple polygons with 4-10 nodes). This dataset crashed the
first version of "your" QGIS. Now it works without a hitch. Drawing time is around 10 seconds versus 20 seconds using the ordinary version of QGIS. This

is nice ;-) !l

Regards
Bo Victor Thomsen
Aests-GIS

Denmark

#92 - 2013-11-16 03:55 AM - Alvaro Huarte

Bo Victor Thomsen wrote:

Hi Alvaro -

| just tried your new version of QGIS on my Postgis-based dataset (1.3 million buildings, i.e simple polygons with 4-10 nodes). This dataset crashed
the first version of "your" QGIS. Now it works without a hitch. Drawing time is around 10 seconds versus 20 seconds using the ordinary version of
QGIS. This is nice ;-) !!

Regards

Bo Victor Thomsen

Aests-GIS

Denmark

You have used the last window installer ( http://www.filedropper.com/qgis-osgeo4w-210-f8725-setup-x8640 ) ?

if so I'm glad | seem to have fixed my problems by making the installer.

For shapefiles, although it depends on the data (#records, size of geometries...), the improvement is still greater.

Thank you very much!

#93 - 2013-11-16 06:29 AM - Bo Victor Thomsen

Yes, | did use your latest version of QGIS. The drawing sped of QGIS with the postgis dataprovider is now compareable with Mapinfo using it's native file
format (Same dataset 1.3 mill. polygons, Mapinfo w. tabfile: 8 seconds, QGIS w. Postgis: 10 seconds)

Regards

Bo Victor Thomsen

#94 - 2013-11-17 04:37 PM - Alvaro Huarte

This up guys! :-)

My proposed pull request (http://trac.osgeo.org/gdal/ticket/5272#comment:7) in GDAL-OGR library for optimize the OGR SHP-provider was accepted and

Even Rouault has commited the modification with extra contributions.

The last windows installer already contains this improvement, really it contains my porposed pull, but they are equivalents.

Thanks Even!
#95 - 2013-11-18 12:42 AM - Giovanni Manghi

Alvaro Huarte wrote:

This up guys! )

My proposed pull request (http.//trac.osgeo.org/gdal/ticket/5272#comment:7) in GDAL-OGR library for optimize the OGR SHP-provider was

accepted and Even Rouault has commited the modification with extra contributions.

very nice done Alvaro!

until now the feedback | received is very good, with no noticeable major issue caused by your patch. We will keep testing.

#96 - 2013-11-18 07:56 AM - Joao Gaspar

My feedback:

OS: Windows 7 64-bits

Processor: Intel(R) Core(TM)2 Duo CPU T8300 @ 2.4GHz 2.4GHz

RAM: 4.00Gb

QGIS Version: QGIS standalone Testing of the Alvaro(32-bits)

Results:

| test two shapefiles:

-Contours of Portugal (30 meters distance) size 300mb of capacity (with a lot of table features)

Results:
With patch: 4 seconds to load / Without patch: 25 seconds to load

- Landuse Level 2 of Portugal size 25mb of capacity (also with a lot of table features)

Results:
With patch: 11 seconds to load / Without patch: more then a 1 minute to load

| think if you create a spatial index in shapefile will help this option of rendering and save a cople of seconds to load.

With simplify rendering on, is necessary notice the users that this option improve rendering but create some gaps in the visualization process that can be

fix after the load of the shapefile and zooming to the desarible scale.

hope this feedback helps.

Great job Alvaro.

Regards

#97 - 2013-11-19 06:39 AM - Alvaro Huarte
Jodo Gaspar wrote:

My feedback:

OS: Windows 7 64-bits

Processor: Intel(R) Core(TM)2 Duo CPU T8300 @ 2.4GHz 2.4GHz

RAM: 4.00Gb

QGIS Version: QGIS standalone Testing of the Alvaro(32-bits)

Results:

| test two shapefiles:

-Contours of Portugal (30 meters distance) size 300mb of capacity (with a lot of table features)

Results:
With patch: 4 seconds to load / Without patch: 25 seconds to load

- Landuse Level 2 of Portugal size 25mb of capacity (also with a lot of table features)

Results:

With patch: 11 seconds to load / Without patch: more then a 1 minute to load

| think if you create a spatial index in shapefile will help this option of rendering and save a cople of seconds to load.

With simplify rendering on, is necessary notice the users that this option improve rendering but create some gaps in the visualization process that
can be fix after the load of the shapefile and zooming to the desarible scale.

hope this feedback helps.

Great job Alvaro.

Regards

Thank your very much to all!

| am developing other improvement in GDAL related with this patch. Therefore | will release other windows installer and | will append a "warning" label
indicating that increase factor may lead to the emergence of gaps.

But these gaps should not appear in the scroll at least, Joao, it is right?

Thanks!

#98 - 2013-11-19 08:40 AM - Joao Gaspar

Sorry my English sometimes tricks me. :p

| don't understand what you want to say with "not appear in the scroll at least".

#99 - 2013-11-19 08:51 AM - Alvaro Huarte
Jodo Gaspar wrote:

Sorry my English sometimes tricks me. :p

| don't understand what you want to say with "not appear in the scroll at least".

No, my English is bad :-P, | trying to say: if you view gaps when the value of simplification factor configured (slider in the fast-rendering form of the layer) is

the mininum.

#100 - 2013-11-19 09:29 AM - Joao Gaspar

Ahaha. ;)

In the minimum level don't appear gaps is "clean and smooth". ;)

Only appears when i increase the slider to high values of simplify geometries.

regards

#101 - 2013-11-19 12:07 PM - Alvaro Huarte

Jodo Gaspar wrote:

Ahaha. ;)

In the minimum level don't appear gaps is "clean and smooth". ;)

Only appears when i increase the slider to high values of simplify geometries.

regards

:-), ok, That's reassuring to me, with the minimum value occurs simplification but should not leave gaps. I'll put a warning for higher values because in

those cases it may appear.

Regards

#102 - 2013-11-20 02:14 AM - Regis Haubourg

Hi Alvaro, | tested your windows package, this is huge! Many thanks...

As a GIS administrator, | would need a general option in QGIS settings to set default behaviour and simplification level for new layers. Is that possible? We
will have to deal ggs migration, could we be sure that layers coming from older QGIS will get these default QGIS settings?

Cheers

Régis

#103 - 2013-11-20 02:25 AM - Alvaro Huarte
- File WarningLabel.jpg added
Alvaro Huarte wrote:

Jodo Gaspar wrote:

My feedback:

OS: Windows 7 64-bits

Processor: Intel(R) Core(TM)2 Duo CPU T8300 @ 2.4GHz 2.4GHz

RAM: 4.00Gb

QGIS Version: QGIS standalone Testing of the Alvaro(32-bits)

Results:

| test two shapefiles:

-Contours of Portugal (30 meters distance) size 300mb of capacity (with a lot of table features)

Results:
With patch: 4 seconds to load / Without patch: 25 seconds to load

- Landuse Level 2 of Portugal size 25mb of capacity (also with a lot of table features)

Results:
With patch: 11 seconds to load / Without patch: more then a 1 minute to load

| think if you create a spatial index in shapefile will help this option of rendering and save a cople of seconds to load.

With simplify rendering on, is necessary notice the users that this option improve rendering but create some gaps in the visualization process that

can be fix after the load of the shapefile and zooming to the desarible scale.

hope this feedback helps.

Great job Alvaro.

Regards

Thank your very much to all!
| am developing other improvement in GDAL related with this patch. Therefore | will release other windows installer and | will append a "warning”

label indicating that increase factor may lead to the emergence of gaps.

But these gaps should not appear in the scroll at least, Jo&o, it is right?
Thanks!

Hi Jo&o,
| added a warning label that appears when the user increases the simplification factor above the minimum level.
Rendering
|| Fast drawing
MNote: This option enables geometry simplification drawing for fast rendering of the layer.
Simplification factor (Higher value draws more simplified geometries): CO='

Warning:
1 Be careful increasing this factor, a further simplification the drawing is faster
but may appear topological distortions in the output map {gaps).

Regards

#104 - 2013-11-20 02:32 AM - Alvaro Huarte
regis Haubourg wrote:

Hi Alvaro, | tested your windows package, this is huge! Many thanks...

As a GIS administrator, | would need a general option in QGIS settings to set default behaviour and simplification level for new layers. Is that
possible? We will have to deal qgs migration, could we be sure that layers coming from older QGIS will get these default QGIS settings?
Cheers

Régis

Hi Régis, thanks!
| can append a general option, | write it down on my to-do list.

Regards

#105 - 2013-11-20 04:01 AM - Alvaro Huarte

Alvaro Huarte wrote:

Hi Jodo,
| added a warning label that appears when the user increases the simplification factor above the minimum level.

Rendering
|| Fast drawing

Note: This aption enables geometry simplification drawing for fast rendering of the layer
Simplification factor {Higher value draws more simplified geometries): CO=‘

Warning:
& Be careful increasing this factor, a further simplification the drawing is faster
but may appear topological distortions in the output map {gaps).

To describe it a little better, check the box performs the drawing simplification and accelerates the render of geometries. If the simplification factor is the

minimum value, must not appear gaps, the more you increase it, is more likely to appear and so in these cases | present the warning.

As a user | do not need to increase the default value except in extreme cases of very large datasets.
#106 - 2013-11-20 06:34 AM - Joao Gaspar
Yeah really good. Describes perfectly the situation. =)

Regards

#107 - 2013-11-20 01:06 PM - Nyall Dawson
Can | suggest some improvements in the strings?

"Fast drawing" -> "Simplify geometry"

"Note ..." -> "Note: Enabling this option simplifies geometries in this layer to improve rendering speed. The simplification applies only during rendering of the
layer and does not modify the layer geometry."

"Simplification factor..." -> "Simplification factor (higher values result in more simplification):"

"Warning..." -> "Warning: Increasing this factor will further speed up rendering, but may result in gaps or topological errors in the layer display."

#108 - 2013-11-20 02:23 PM - Alvaro Huarte
- File WarningLabel2.jpg added

Nyall Dawson wrote:
Can | suggest some improvements in the strings?
"Fast drawing" -> "Simplify geometry"

"Note ..." -> "Note: Enabling this option simplifies geometries in this layer to improve rendering speed. The simplification applies only during
rendering of the layer and does not modify the layer geometry."

"Simplification factor..." -> "Simplification factor (higher values result in more simplification):"

"Warning..." -> "Warning: Increasing this factor will further speed up rendering, but may result in gaps or topological errors in the layer display."

Done, thank you very much Nyall!

Rendering
1% Simplify geometry -
Note:

Enabling this option simplifies geometries in this layer to improve rendering speed. The simplification applies only during
rendering of the layer and does not modify the layer geometry.

Simplification factor (higher values result in more simplification):

Warning:
@\_ Increasing this factor will further speed up rendering, but may result in gaps
or topological errors in the layer display.
#109 - 2013-11-20 04:30 PM - Rui Pedro Henriques

Hi, I've tested this on Win7 64 bit with a previous project containing several raster and vector layers. Surprinsingly the whole set got slower: even while
having only 2 layers enabled it got really heavy and also affected the scroll of the layers list. For the moment I'm not able to provide the dataset | was
working on but I'll try to recreate the problem with a dataset | can supply.

Trying with a clean project with just one (complex) vector layer did speed up things.

Anyone else noticed something similar?

#110 - 2013-11-21 05:04 AM - Alvaro Huarte

rph - wrote:

Hi, I've tested this on Win7 64 bit with a previous project containing several raster and vector layers. Surprinsingly the whole set got slower: even
while having only 2 layers enabled it got really heavy and also affected the scroll of the layers list. For the moment I'm not able to provide the
dataset | was working on but I'll try to recreate the problem with a dataset | can supply.

Trying with a clean project with just one (complex) vector layer did speed up things.

Anyone else noticed something similar?

Hi, | tried to reproduce this behavior and have not succeeded. | see no connection with this patch, but anyway this QGIS has not linked all data providers,
it only contains most popular for test.

Regards

#111 - 2013-11-21 05:11 AM - Giovanni Manghi

Anyone else noticed something similar?

can you try remove the layers (one by one) from your project and see if you find one that can be the cause?

Anyone else noticed something similar?

I may have seen this (but not sure) with a specific vector layer, made of a lot of polygons that are not possible to simplify, because it is grid polygon vector

made of perfect squares.

In this case seem that qgis takes a lot trying figure how simplify, eventually taking an overhead. But as | said is just an impression as | have not tested it
seriously. Example

https://www.dropbox.com/s/2leh363cdbupg1w/grid25_clip.tar.gz

#112 - 2013-11-21 06:43 AM - Alvaro Huarte

Giovanni Manghi wrote:

Anyone else noticed something similar?
can you try remove the layers (one by one) from your project and see if you find one that can be the cause?
Anyone else noticed something similar?

I may have seen this (but not sure) with a specific vector layer, made of a lot of polygons that are not possible to simplify, because it is grid polygon
vector made of perfect squares.

In this case seem that qgis takes a lot trying figure how simplify, eventually taking an overhead. But as | said is just an impression as | have not
tested it seriously. Example

https.//www.dropbox.com/s/2leh363cdbupg1w/grid25 clip.tar.gz

What you're saying makes sense, | may be trying to simplify polygons with <=5 points (grids) which themselves are not generalizable,
I look, thanks Giovanni!!

#113 - 2013-11-21 07:40 AM - Alvaro Huarte

Alvaro Huarte wrote:

Giovanni Manghi wrote:
| Anyone else noticed something similar?
can you try remove the layers (one by one) from your project and see if you find one that can be the cause?
| Anyone else noticed something similar?

I may have seen this (but not sure) with a specific vector layer, made of a lot of polygons that are not possible to simplify, because it is grid polygon
vector made of perfect squares.

In this case seem that qgis takes a lot trying figure how simplify, eventually taking an overhead. But as | said is just an impression as | have not
tested it seriously. Example

https.//www.dropbox.com/s/2leh363cdbupg1w/grid25 clip.tar.gz

What you're saying makes sense, | may be trying to simplify polygons with <=5 points (grids) which themselves are not generalizable,
| look, thanks Giovanni!!

| answer to myself :-), the patch try not to simplify polygons of 5 points, or linestrings of 2 points, but try to find out if it is possible to disable the
'AntiAliasing' for render the geometry faster. If the end is not possible to disable the AA (The geometry is not so far), an overload occurs in the process.

This can be avoided disabling for this layer the drawing simplification.

#114 - 2013-11-21 03:30 PM - Alvaro Huarte
- File DefaultSimplifyConfig.jpg added

regis Haubourg wrote:
Hi Alvaro, | tested your windows package, this is huge! Many thanks...
As a GIS administrator, | would need a general option in QGIS settings to set default behaviour and simplification level for new layers. Is that
possible? We will have to deal qgs migration, could we be sure that layers coming from older QGIS will get these default QGIS settings?

Cheers
Régis
Done!
iy, Rendering
& General E
o ~Rendering behavior
vﬁ System N
(3| By default new layers added to the map should be displayed
Batitotines [3¢] Enable badk buffer
( Rendering Number of features to draw before updating the display | so000 %—:
e Hote: Set below 1000 to prevent display updates until all features have been rendered
[EJ Canvas & Legend
|| Use render caching where possible to speed up redraws
Braml
[L_ hj Map Toals ’ 13| By default simplify geometries i
[Fa¥] Digitizing By default new vector layers added to the map should simplify geometries to improve rendering speed. The
simplification applies only during rendering of the layer and does not modify the layer geometry.
Ei:l'l'_\ GDAL Simplification factor (higher values result in more simplification): U:'
B
~Rendering quality
a Locale N
- 3| Make lines appear less jagged at the expense of some drawing performance
573"5 Network || Fix problems with incorrectly filed polygons s
-Rasters
RGB band selecion  Red band | 1 LT:___; Green band |_2 ;—} Blue band | i;f—|
~—Contrast enhancement
Single band gray lStretch To MinMax | - |
Multi band color (byte fband) | Mo Stretch | v]
Multi band color (> byte fband) | Stretch To MinMax |=] E
[ oK ] | Cancel || Hep |
Regards

#115 - 2013-11-21 05:46 PM - Alvaro Huarte
- File deleted (sketch.png)

#116 - 2013-11-21 06:23 PM - Alvaro Huarte

Hi,

| release a new windows installer which contains:

- Patch #8725 of QGIS (https://github.com/qgis/QGIS/pull/980)

- Patch #9062 of QGIS (#9062)
- Patch N5272 of GDAL (http:/trac.osgeo.org/gdal/ticket/5272)
http://www.filedropper.com/qgis-osgeo4w-210-f8725-setup-x86v50

I made new tests with the latest version to see the speed.

Soft/hard: WindowsXP+SP3, 32bits, 4gb RAM.

My shapefiles tested:

2025-04-26

Dataset Value Master Patched
http://fauna |iterations |5 5
lia.pt/downl
0ads/GTBs
_Shapefile.
zip
total_avg 214,14063 (84,29375 |39%
total_max |[222,53125 |85,39063
total_maxd [29,60938 |1,21563
ev
total_min 184,53125 |83,07813
total_stdev | 14,81578 (0,93151
http://fauna | iterations |5 5
lia.pt/downl
oads/MAM
MTERR.zip
total_avg [86,60938 [10,60625 |12%
total_max [98,96875 [13,39063
total_maxd [46,48438 |2,78438
ev
total_min 40,12500 |9,81250
total_stdev |283,24727 1,39311
http://www. |iterations |5 5
igeo.pt/scri
f/erif/CRIF2
011shp.zip
total_avg 287,47500 (67,36250 |23%
total_max |[307,04688 |77,32813
total_maxd |[75,53750 [9,96563
ev
total_min 211,93750 |64,78125
total_stdev |37,77141 |4,98346
https://www | iterations |5 5
.dropbox.co
m/s/2leh36
3cdbupgiw
/grid25_clip
tar.gz
total_avg 100,86250 |54,27500 |54%
total_max |[101,20313 |55,20313
total_maxd | 0,72187 2,93125
ev
total_min 100,14063 |51,34375
total_stdev [0,38151 1,46910
http://idena | iterations | 5 5
.navarra.es

/descargas

/CARTO1_

Lin_6CNive

ID.zip
total_avg |[7,98125 1,30000 16%
total_max [9,35938 2,14063
total_maxd |4,30938 0,84063
ev
total_min  |3,67188 1,06250
total_stdev |2,16033 0,42175

http://idena |iterations |5 5

.navarra.es

/descargas

/GEOLOG_

Pol_Litolog

ia.zip
total_avg 9,97188 1,79063 18%
total_max [11,26563 |2,84375
total_maxd | 4,95625 1,05313
ev
total_min  [5,01563 1,50000
total_stdev | 2,47837 0,52697

Urban iterations 5 5 total_avg 50,28438 (10,01563 |[20%

parcels of

cadastre of

navarra

(Polygon2D

of 142680

records,

66mb)
total_max |[55,93750 |14,60938
total_maxd [22,23750 [4,59375
ev
total_min 28,04688 |8,81250
total_stdev [11,11898 [2,29725

Rustic iterations |5 5

parcels of

cadastre of

navarra

(Polygon2D

of 542658

records,

458mb)
total_avg [10,17500 |2,65938 26%
total_max [11,04688 |2,68750
total_maxd |3,37813 0,02813
ev
total_min 6,79688 2,64063
total_stdev | 1,68913 0,01822

#117 - 2013-11-22 12:13 AM - Nyall Dawson
Here's some more string updates for this latest addition:

"By default simplify geometries" -> "Simplify geometries by default"

And for the text below the checkbox:

"If checked, new vector layers added to the map will automatically use geometry simplification to speed up rendering. ... (then the rest of what you have)"

Thanks!

#118 - 2013-11-22 12:37 AM - Nyall Dawson

Alvaro - these improvements look fantastic! Your hard work is much appreciated!

One related idea | was planning on investigating was adding an option to disable rendering of features smaller than a certain size (in mm). You'll see a
similar option in the labelling properties for a vector layer under "Rendering" -> "Suppress labelling of features smaller than ". Having the ability to skip
rendering of small features could potentially lead to some more performance gains (as well as having cartographic benefits). Obviously, it should be

disabled by default for layers as it would only be useful in some circumstances.

There was a bit of discussion on the QGIS dev list about this a month or so ago -- | had a quick initial attempt at implementing it but have got side tracked

on composer work (and it's looking like this will tie me up for the whole of the 2.2 dev cycle).

If you wanted to experiment with this, there's code for checking the size of a feature in mm in QgsPalLayerSettings::checkMinimumSizeMM . | had a quick
play here https:/github.com/nyalldawson/QGIS/commit/27a42e11b31521a521f8435fc4e82d75568c97cb (no gui, hard coded to a minimum size of 2mm)
which yielded some benefit. This was done in QgsVectorLayer::drawRendererV2, | think moving it further up the chain could improve the performance

some more.

#119 - 2013-11-22 12:50 AM - Alvaro Huarte

Nyall Dawson wrote:

Here's some more string updates for this latest addition:

"By default simplify geometries" -> "Simplify geometries by defauit"

And for the text below the checkbox:

"If checked, new vector layers added to the map will automatically use geometry simplification to speed up rendering. ... (then the rest of what you
have)"

Thanks!

Done, thanks Nyall!

#120 - 2013-11-22 07:43 AM - Alvaro Huarte

Nyall Dawson wrote:

Alvaro - these improvements look fantastic! Your hard work is much appreciated!
One related idea | was planning on investigating was adding an option to disable rendering of features smaller than a certain size (in mm). You'll see
a similar option in the labelling properties for a vector layer under "Rendering" -> "Suppress labelling of features smaller than ". Having the ability to
Skip rendering of small features could potentially lead to some more performance gains (as well as having cartographic benefits). Obviously, it
should be disabled by default for layers as it would only be useful in some circumstances.

There was a bit of discussion on the QGIS dev list about this a month or so ago -- | had a quick initial attempt at implementing it but have got side
tracked on composer work (and it's looking like this will tie me up for the whole of the 2.2 dev cycle).

If you wanted to experiment with this, there's code for checking the size of a feature in mm in QgsPallLayerSettings::checkMinimumSizeMM . | had a
quick play here https://github.com/nyalldawson/QGIS/commit/27a42e11b31521a521f8435fc4e82d75568c97cb (no gui, hard coded to a minimum
size of 2mm) which yielded some benefit. This was done in QgsVectorLayer::drawRendererV2, | think moving it further up the chain could improve

the performance some more.

Hi Nyall, | did not know this discussion!, | have involved in QGIS later. Coincidences of life, this patch proposes an implementation of that issue. Now, I'm a

little waiting for comments and suggestions to see if it is interesting to approval.

On the subject of not paint "very small" elements seems like a good idea in case of layers as you mention, in other cases (very dense layers) would appear

whole areas unpainted, but | would not mix this with this patch but on a new patch. If you want | can try to implement it.

Regards

#121 - 2013-11-22 01:05 PM - Nyall Dawson

Alvaro Huarte wrote:

Hi Nyall, I did not know this discussion!, | have involved in QGIS later. Coincidences of life, this patch proposes an implementation of that issue.
Now, I'm a little waiting for comments and suggestions to see if it is interesting to approval.

I know - it's great timing! Thanks for all the work you've put in developing these much needed improvements for QGIS.

On the subject of not paint "very small" elements seems like a good idea in case of layers as you mention, in other cases (very dense layers) would

appear whole areas unpainted, but | would not mix this with this patch but on a new patch. If you want | can try to implement it.

| don't want to add to your workload, but it'd be great if you could check it out. I've realized I'm not going to get a chance to tackle this for 2.2. Based on

your past work you've got a much better understanding of optimising code like this then | do!

#122 - 2013-11-22 02:18 PM - Alvaro Huarte

Nyall Dawson wrote:

Alvaro Huarte wrote:

Hi Nyall, I did not know this discussion!, | have involved in QGIS later. Coincidences of life, this patch proposes an implementation of that issue.

Now, I'm a little waiting for comments and suggestions to see if it is interesting to approval.
| know - it's great timing! Thanks for all the work you've put in developing these much needed improvements for QGIS.

‘ On the subject of not paint "very small" elements seems like a good idea in case of layers as you mention, in other cases (very dense layers) would
appear whole areas unpainted, but | would not mix this with this patch but on a new patch. If you want | can try to implement it.

I don't want to add to your workload, but it'd be great if you could check it out. I've realized I'm not going to get a chance to tackle this for 2.2. Based

on your past work you've got a much better understanding of optimising code like this then | do!

Thanks Nyall, | also really appreciate the tests, advice and opinions of the community, they serve me to keep learning every day. And your english
corrections ;-)
#123 - 2013-11-26 02:11 AM - Jeremy Palmer
I've just seen this pull request. Dumb question, but why would you implement the user defined
simplification setting? Seems to me it should be sorted by the software automatically, based on extent and the map to pixel setting. Is also overly
complicated for the user...
#124 - 2013-11-26 02:30 AM - Alvaro Huarte
Jeremy Palmer wrote:
I've just seen this pull request. Dumb question, but why would you implement the user defined
simplification setting? Seems to me it should be sorted by the software automatically, based on extent and the map to pixel setting. Is also overly
complicated for the user...

Hi Jeremy, the software automatically calculates the simplification factor based on geometry and current map2pixel setting (Slider with minimum value).

| added the possibility of increase this factor to get 'extra’ simplification to accelerate even more the render of very large layers.

In this case it is possible that appear gaps and one warning message is showed in the configuration panel.

As | said above the user, in most cases, do not worry about modifying this value, but in other cases it may be interesting.

Regards

#125 - 2013-12-08 02:31 AM - Jeremy Palmer

Hi Alvaro,

Thanks for the reply. In that case it might be worth stating on the slider label that it is a advanced experimental option.

Cheers,

Jeremy

#126 - 2013-12-08 03:00 AM - Alvaro Huarte

Jeremy Palmer wrote:

Hi Alvaro,

Thanks for the reply. In that case it might be worth stating on the slider label that it is a advanced experimental option.
Cheers,

Jeremy

Hi Jeremy, | suppose we should add an entry in the user manual and explain this configuration.
Thanks!

Alvaro

#127 - 2013-12-12 03:05 PM - Alvaro Huarte

Hi all, There is a modification in behavior of this patch (https://github.com/qgis/QGIS/pull/980).

Now, it contains the advise of @nyalldawson (https:/github.com/qgis/QGIS/pull/1020#issuecomment-30263200) to enable AA-disabling only when the

simplification slider is greater than minimum value.

Best regards

#128 - 2013-12-13 04:10 PM - Alvaro Huarte

- File BadSimplificationWithOffset.jpg added

#129 - 2013-12-17 08:11 AM - Alvaro Huarte

| am pleased to announce that this patch seems to have been merged!

)

Thank you very much for your support and advices!

#130 - 2013-12-17 08:18 AM - Giovanni Manghi

Alvaro Huarte wrote:

I am pleased to announce that this patch seems to have been merged!

=)

Thank you very much for your support and advices!

Alvaro, many thanks to YOU :)

#131 - 2013-12-17 08:18 AM - Giovanni Manghi
- Status changed from Open to Closed
- Resolution set to fixed/implemented

#132 - 2013-12-17 08:28 AM - Alvaro Huarte

What about add documentation to user manual?
#133 - 2013-12-17 01:10 PM - Jiirgen Fischer

merged in commit:17cd09a8a7352d761602c547d29f660aed219adb

#134 - 2013-12-26 04:12 PM - Alvaro Huarte

Hi, | committed a new version of geometry simplification to speed up the vector drawing.

https://github.com/ahuarte47/QGIS/tree/Issue_8725-revival-optA-to-B

Itis inspired in this PR, but it contains several changes based on advice received ( @matthias-kuhn thanks! ) and new features:

- About code, the simplification is configured in a new QgsSimplifyMethod class which indicates how to simplify the geometries in a feature iterator.

- Now, the user can define where the simplification executes (There is a new option in settings panel), locally after fetch the geometry from provider, or

simplifying it on provider side. e.g. In postgres provider, first option simplifies the geometry already fetched locally, but the second option simplifies the

geometry in database using the function ST_Simplify.

- The settings panel also shows the simplification threshold in pixel units as @timlinux suggested me.

| have not created a new pull request because of | would greatly appreciate if you could test it with your data and SO's. | have tested it in windows | get

similar results as old version for shapefiles (OGR-provider). The new simplification on database side for postgres provider improves the old results too. |

will create a table of tests to compare data and configurations.

About postgres simplification, the ST_simplify function needs a tolerance parameter, | use map2pixel/5.0 as input value, it is experimental and | must

define it better (All ideas are welcome). This simplification can be applicable to other database providers (MySQL, SQL Server, Oracle...)

Thank you very much!
